#include "oxfloat.h"
#include "oxmath.h"

namespace OX {
	namespace {
		const Float3 float3Zero(0.0f, 0.0f, 0.0f);

		const Float4x4 idm(
			1.0f, 0.0f, 0.0f, 0.0f,
			0.0f, 1.0f, 0.0f, 0.0f,
			0.0f, 0.0f, 1.0f, 0.0f,
			0.0f, 0.0f, 0.0f, 1.0f);

		const Float4x4 m0(
			0.0f, 0.0f, 0.0f, 0.0f,
			0.0f, 0.0f, 0.0f, 0.0f,
			0.0f, 0.0f, 0.0f, 0.0f,
			0.0f, 0.0f, 0.0f, 0.0f);

		const Float4x3 idm4x3(
			1.0f, 0.0f, 0.0f,
			0.0f, 1.0f, 0.0f,
			0.0f, 0.0f, 1.0f,
			0.0f, 0.0f, 0.0f);

		const Float4x3 m04x3(
			0.0f, 0.0f, 0.0f,
			0.0f, 0.0f, 0.0f,
			0.0f, 0.0f, 0.0f,
			0.0f, 0.0f, 0.0f);
	}

	// [xNg擾
	const Float3 &Float3::getZero() {
		return float3Zero;
	}

	// Pʍs擾
	const Float4x4 &Float4x4::getIdentity() {
		return idm;
	}

	// [s擾
	const Float4x4 &Float4x4::getZero() {
		return m0;
	}

	// ΊpPʍs擾
	const Float4x3 &Float4x3::getIdentity() {
		return idm4x3;
	}

	// [s擾
	const Float4x3 &Float4x3::getZero() {
		return m04x3;
	}

	// NH[^jI]
	Quaternion &Quaternion::setAsRotDeg(const Float3 &axis, float deg) {
		return setAsRot(axis, OX::Math::toRad(deg));
	}
}