#ifndef IKD_OX_BASIC_OXMATH_H
#define IKD_OX_BASIC_OXMATH_H

// w֐Q

#include "oxfloat.h"

namespace OX {
	class Math {
	public:
		static const float pi;		// 
		static const float inv_pi;	// 1/
		static const float _2pi;	// 2
		static const float inv_pi2;	// 1/2

		// Βl
		static float fabs(float v) {
			// _͍ŏʃrbgŕf
			unsigned res = (*reinterpret_cast<unsigned*>(&v) & 0x7fffffff);
			return *reinterpret_cast<float*>(&res);
		}

		// _Ԃׂ̋̂
		template<class T>
		static float lengthSq(const T& p1, const T& p2) {
			return (p1 - p2).lengthSq();
		}
		static float lengthSq(const float& p1, const float& p2) {
			return (p1 - p2) * (p1 - p2);
		}

		// ׂ
		static float pow2(float v) {
			return v * v;
		}

		// Nv
		//  l`r̊ԂɃNv
		static float clamp(float v, float l, float r) {
			return v < l ? l : (v > r ? r : v);
		}

		// WAfO[
		static float toDeg(float rad) {
			return 360.0f / _2pi * rad;
		}
		static Float3 toDeg(const Float3 &rad) {
			return Float3(toDeg(rad.x), toDeg(rad.y), toDeg(rad.z));
		}

		// fO[WA
		static float toRad(float deg) {
			return deg * _2pi / 360.0f;
		}
		static Float3 toRad(const Float3 &deg) {
			return Float3(toRad(deg.x), toRad(deg.y), toRad(deg.z));
		}

		// `
		template<class T>
		static T linear(const T& v1, const T& v2, float t) {
			return (1.0f - t) * v1 + t * v2;
		}

		// cot
		static float cotf(float v) {
			return 1.0f / tanf(v);
		}
	};
}

#endif
