#include "testlayout.h"

namespace OX {
	namespace Layout {
		///////////////////////
		// ҋ@Xe[g
		////
		void TurnRedObject::IdleState::initialize(Object &env) {
			TurnRedObject &owner = (TurnRedObject&)env;
			owner.param.color = 0xffffffff;
			bClicked = false;
		}

		Object::State *TurnRedObject::IdleState::update(Object &env, unsigned advance) {
			return bClicked ? getNextState(0) : this;
		}

		// }EXANV
		void TurnRedObject::IdleState::mouseAction(Object &env, Mouse &mouse) {
			TurnRedObject &owner = (TurnRedObject&)env;

			// NbNꂽp[^ԐFɂ
			if (mouse.isDown(Mouse::L) && env.isContain(mouse.getPos())) {
				bClicked = true;

				// t@N^[ɘA
				for (unsigned i = 0; i < owner.functors.size(); i++)
					owner.functors[i]->run();
			}
		}


		///////////////////////////
		// Ɖ]Xe[g
		////
		void TurnRedObject::RotateState::initialize(Object &env) {
			TurnRedObject &owner = (TurnRedObject&)env;
			owner.param.color = 0xffff0000;
			curTime = 0;
		}

		Object::State *TurnRedObject::RotateState::update(Object &env, unsigned advance) {
			TurnRedObject &owner = (TurnRedObject&)env;

			curTime += advance;
			float t = (float)curTime / rotTime;
			t = t > 1.0f ? 1.0f : t;

			owner.param.rot = 360.0f * t;

			return (t >= 1.0f) ? getNextState(0) : this;
		}


		///////////////////////
		// TurnRedObject
		////
		TurnRedObject::TurnRedObject() {
		}

		TurnRedObject::~TurnRedObject() {
		}

		// 
		void TurnRedObject::initialize() {
			IdleState *idle = createNewState<IdleState>();
			RotateState *rotate = createNewState<RotateState>();
			idle->setNextState(0, rotate);
			rotate->setNextState(0, idle);
			setEntryState(idle);
		}

		// }EXANV
		void TurnRedObject::mouseAction(Mouse &mouse) {
			curState->mouseAction(*this, mouse);
		}
	}
}